// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
	stop_monitoring_system();
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
	start_monitoring_system();
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

var _update_timer_interval = null;

function start_monitoring_system(){
	
	update_information();

    if (!_update_timer_interval){
        _update_timer_interval = setInterval(update_information, 5*1000);
	}
}


function update_information() {

	var today = (new Date()).getTime();
	
	var tmp = modified_Time('/private/var/log/daily.out');
	
	var date_of_daily	= today - modified_Time('/private/var/log/daily.out').getTime();
	
	
	var date_of_weekly	= today - modified_Time('/private/var/log/weekly.out').getTime();
	var date_of_monthly = today - modified_Time('/private/var/log/monthly.out').getTime();

	document.getElementById("daily").innerText = round_numer(date_of_daily/3600000,1);
	document.getElementById("weekly").innerText	= round_numer(date_of_weekly/86400000,1);
	document.getElementById("monthly").innerText= round_numer(date_of_monthly/86400000,1);		

}

function stop_monitoring_system(){
    if (_update_timer_interval) {
        clearInterval(_update_timer_interval);
        _update_timer_interval = null;
    }
}

function modified_Time(file){
	
	var command = "/usr/bin/perl -le '@data = stat(\"" + file + "\"); ($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime($data[9]);$str = sprintf(\"%02d/%02d/%04d %02d:%02d:%02d\",$mon+1,$mday,$year+1900,$hour,$min,$sec);print $str;'";

	var stdout = widget.system(command, null).outputString;
	var date = new Date(stdout.replace(/\n/g,""));
		
	return date;
}

function do_maintenance_script(){
	showFront();
	do_appleScript('tell application "Terminal" to do script "sudo periodic daily weekly monthly"');
}

function do_appleScript(command) {
	
	if (window.widget){
		var obj = widget.system("/usr/bin/osascript -e  "+ "'" + command + "'",null);
		return obj.outputString;
		} else {
		return null;
		}
}

function on_signature_clicked(event)							// jump to Dan's blog.
{	showFront();
	widget.openURL('http://blog.goo.ne.jp/howesound/');
}


// basic functions

function round_numer(value,pos){
	return Math.round(value * Math.pow(10,pos)) /Math.pow(10,pos);
}


function string_between(str, delimiter1,delimiter2)	
{	
	str = str.substring(str.indexOf(delimiter1),str.length);
	str = str.substring(delimiter1.length,str.indexOf(delimiter2,0));
	return(str);
}

function delimitered_by(str,delimiter)
{	//return array delimiterd by str.
	
	var aArray = new Array();
	
	if(str.indexOf(delimiter) < 0)
	{ return([str]);
	}
	
	do {    index = str.indexOf(delimiter);
			each = str.substr(0,index)
			aArray.push(each);
			str = str.substr(index+delimiter.length,str.length)
		} while (str.indexOf(delimiter)>=0);
		
	aArray.push(str);
	return(aArray);
}
