// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    // widget.setPreferenceForKey(null, createInstancePreferenceKey("your-key"));
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
	stop_monitoring_system();

}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
	start_monitoring_system();
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}

var _top_command = null;	// Top command instance

function start_monitoring_system(){
	//_top_command = widget.system('/usr/bin/top -S -s 2', endSystem); // 2 seconds update.
	_top_command = widget.system('/usr/bin/top -S -s 2 -n 0', endSystem); // 2 seconds update.
	_top_command.onreadoutput = readOutput;
}

function endSystem(event) {
	_top_command = null;
}

function readOutput(stdout) {

  if (_top_command && stdout) {
      if (stdout.indexOf("Processes") != -1) {
		var free_memory = memory_usage(stdout,'free');
		var used_memory= memory_usage(stdout,'used');
		
		// used memory.
		var free_memory_kb = convert_memory_size_expression(free_memory);					//into kb
		var total_memory_kb = convert_memory_size_expression(used_memory) + free_memory_kb;	//into kb
		var used_memory_percentage = parseInt(100 - (free_memory_kb/total_memory_kb * 100));
		document.getElementById("memory_free_percentage").innerText = used_memory_percentage + '%';

		// free memory
		document.getElementById("memory_free").innerText = '( ' + auto_convert_memory_size_expression(free_memory_kb) + ' free )';
		
		// swap file size
		var swap_all	= convert_memory_size_expression(swap_usage(stdout,'free')) + convert_memory_size_expression(swap_usage(stdout,'used')); //all
		document.getElementById("swap_all").innerText = auto_convert_memory_size_expression(swap_all);
		
		// swap file used.
		var swap_used = convert_memory_size_expression(swap_usage(stdout,'used'));
		document.getElementById("swap_used").innerText = '( ' + auto_convert_memory_size_expression(swap_used) + ' used)';	
	
     }  
  }
}

function stop_monitoring_system(){
	_top_command.cancel();
	_top_command = null;
}

function is_monitoring(){
	return (_top_command =! nil);
}

// parse top stdout.

function cpu_usage(stdout,selector){
	
	var str = string_between(stdout,'CPU usage:','\n');
	var info = delimitered_by(str, ',');
	
	switch (selector) {
		case "user":
			return parseFloat(info[0].replace('% user',''));
		break;
		
		case "sys":
			return parseFloat(info[1].replace('% sys',''));
		break;
		
		case "idle":
			return parseFloat(info[2].replace('% idle',''));
		break;
		
		default:
			return parseFloat(info[2].replace('% idle',''));
		break;
	}
}

function memory_usage(stdout,selector){

	var str = string_between(stdout,'PhysMem:','\n');
	var info = delimitered_by(str, ',');
	
	switch (selector) {
		case "wired":
			return (info[0].replace('wired','')).replace(/ /g,'');
		break;
		
		case "active":
			return (info[1].replace('active','')).replace(/ /g,'');
		break;
		
		case "inactive":
			return (info[2].replace('inactive','')).replace(/ /g,'');
		break;
		
		case "used":
			return (info[3].replace('used','')).replace(/ /g,'');
		break;	
		
		case "free":
			return (info[4].replace('free.','')).replace(/ /g,'');
		break;	
		
		default:
			return (info[4].replace('free','')).replace(/ /g,'');
		break;
	}
}


function swap_usage(stdout,selector){
	
	var str = string_between(stdout,'Swap:','Purgeable:');
	var info = delimitered_by(str, '+');
	
	switch (selector) {
		case "swap_used":
			return info[0].replace(/ /g,'');
		break;
		
		case "free":
			return (info[1].replace('free','')).replace(/ /g,'');
		break;
		
		case "all":
			return str.replace(/^\s+|\s+$/g, "");
		break;
				
		default:
			return info[0].replace(/ /g,'');
		break;
	}
}

function convert_memory_size_expression(expression){
	
	// expression into KB.
	var str = expression.toUpperCase();
	
	// KB, K into KB.
	if((pos = str.indexOf('K')) != -1)	{str = str.substring(0,pos); return Number(str); }
	if((pos = str.indexOf('KB')) != -1)	{str = str.substring(0,pos); return Number(str); }
	
	// MB,M into KB.
	if((pos = str.indexOf('M')) != -1)	{str = str.substring(0,pos); return Number(str)*1000; }
	if((pos = str.indexOf('MB')) != -1)	{str = str.substring(0,pos); return Number(str)*1000; }
	
	// GB,G into KB.
	if((pos = str.indexOf('G')) != -1)	{str = str.substring(0,pos); return Number(str)*1000000; }
	if((pos = str.indexOf('GB')) != -1)	{str = str.substring(0,pos); return Number(str)*1000000; }

	// B into KB.
	if((pos = str.indexOf('B')) != -1)	{str = str.substring(0,pos); return Number(str)/1000; }
	
	return Number(str);

}

function auto_convert_memory_size_expression(memory_kb){
	
	// KB to proper MB.
	
	if(memory_kb >= 1000000){
		return (round_numer(memory_kb/1000000,2) + 'GB');
	}
	
	if(memory_kb >= 1000){
		return (round_numer(memory_kb/1000,0) + 'MB')
	}
	
	return ((memory_kb/1) + 'KB')

}

function number_of_swap_files(){
	var stdout =  widget.system('/bin/ls -l /private/var/vm/swapfile*', null).outputString;
	items = delimitered_by(stdout,'swapfile');
	return items.length-1;
}


function do_memory_purge(){
	showFront();
	do_appleScript('tell application "Terminal" to do script "sudo diskutil verifyPermissions /"');
}

function do_appleScript(command) {
	
	if (window.widget){
		var obj = widget.system("/usr/bin/osascript -e  "+ "'" + command + "'",null);
		return obj.outputString;
		} else {
		return null;
	}
}

function on_signature_clicked(event)							// jump to Dan's blog.
{	showFront();
	widget.openURL('http://blog.goo.ne.jp/howesound/');
}

// basic functions

function round_numer(value,pos){
	return Math.round(value * Math.pow(10,pos)) /Math.pow(10,pos);
}


function string_between(str, delimiter1,delimiter2)	
{	
	str = str.substring(str.indexOf(delimiter1),str.length);
	str = str.substring(delimiter1.length,str.indexOf(delimiter2,0));
	return(str);
}

function delimitered_by(str,delimiter)
{	//return array delimiterd by str.
	
	var aArray = new Array();
	
	if(str.indexOf(delimiter) < 0)
	{ return([str]);
	}
	
	do {    index = str.indexOf(delimiter);
			each = str.substr(0,index)
			aArray.push(each);
			str = str.substr(index+delimiter.length,str.length)
		} while (str.indexOf(delimiter)>=0);
		
	aArray.push(str);
	return(aArray);
}
